package ethz.ch.pp.sum;

public interface Sum {
    /**
     * Computes the sum of the elements in arr using p processors
     * @param arr the array of integers to sum up
     * @param p number of processors that should be used, p > 0
     * @return sum of all elements in arr
     */
    int sum(int[] arr, int p) throws Exception;
}
